Attribute VB_Name = "basDXSurf2"
' Adapted from the DXSurf2 SDK sample
' Original code Copyright(c) 1995-1998 Microsoft Corporation. All rights reserved.
' Ported to Visual Basic using a tweaked type library file by Patrice Scribe
' scribe@chez.com - http://members.xoom.com/vba51
' Uses :
' - DXTrans.tlb (build from a tweaked version of the original DXTrans.idl source file)
' - Win32.tlb

Option Explicit

Public Const CLSCTX_INPROC = 1 ' Not defined in Win32.tlb

Private Sub Main()
    Dim SurfaceFactory As IDXSurfaceFactory  ' Surface factory
    Dim DXSurface1 As DXSurface              ' First surface
    Dim DXSurface2 As DXSurface              ' Second surface
    Dim SurfaceModifier As DXSurfaceModifier ' "Blender"
    Dim PointZero As tagPOINT                ' Origin
    Dim DXSurfaceResult As DXSurface         ' DXSurface interface to "blender"
    Dim DXSurfaceOutput As DXSurface         ' Final output surface
    Dim ClientRect As RECT          ' Window client rect
    Dim Bounds As DXBNDS            ' Bounds for output surface
    Dim DXSurfaceLock As IDXDCLock  ' Lock output surface
    Dim hdcSurface As Long          ' hDC for output surface    ' Initialize UIDs
    Dim Opacity As Single
    DXTransInitialize
    ' Show form
    frmDXSurf2.Show
    ' Create surface factory
    CoCreateInstance CLSID_DXTransformFactory, ByVal 0&, CLSCTX_INPROC, IID_IDXSurfaceFactory, SurfaceFactory
    ' Create surface 1 from file
    SurfaceFactory.LoadImage App.Path & "\tulipshol2.jpg", Nothing, ByVal 0&, DDPF_PMARGB32, IID_IDXSurface, DXSurface1
    ' Create surface 2 from file
    SurfaceFactory.LoadImage App.Path & "\parrot.png", Nothing, ByVal 0&, DDPF_PMARGB32, IID_IDXSurface, DXSurface2
    ' Create surface modifier ("blender")
    CoCreateInstance CLSID_DXSurfaceModifier, ByVal 0&, CLSCTX_INPROC, IID_IDXSurfaceModifier, SurfaceModifier
    ' Set foreground, background
    PointZero.x = 0
    PointZero.y = 0
    SurfaceModifier.SetForeground DXSurface2, False, PointZero
    SurfaceModifier.SetBackground DXSurface1
    ' Retrieve a "pointer" to the result as a DXSurface interface
    Set DXSurfaceResult = SurfaceModifier
    ' Create final output surface
    GetClientRect frmDXSurf2.hWnd, ClientRect
    Bounds.D_DXB_X.Max = ClientRect.Right
    Bounds.D_DXB_Y.Max = ClientRect.Bottom
    Bounds.D_DXB_T.Max = &HFFFFFFFF ' Time
    SurfaceFactory.CreateSurface Nothing, ByVal 0&, ByVal 0&, Bounds, 0, Nothing, IID_IDXSurface, DXSurfaceOutput
    ' Rendering loop
    Do While DoEvents()
        ' Set opacity
        SurfaceModifier.SetOpacity Opacity
        ' "Extract" the result to the output surface
        SurfaceFactory.BitBlt DXSurfaceOutput, ByVal 0&, DXSurfaceResult, ByVal 0&, 1 'DXBOF_DO_OVER
        ' Lock output surface
        DXSurfaceOutput.LockSurfaceDC ByVal 0&, 3000, 0, DXSurfaceLock
        hdcSurface = DXSurfaceLock.GetDC
        ' Blit to window using Win32 API
        GetClientRect frmDXSurf2.hWnd, ClientRect
        BitBlt frmDXSurf2.hDC, 0, 0, ClientRect.Right, ClientRect.Bottom, hdcSurface, 0, 0, SRCCOPY
        ' Release lock
        Set DXSurfaceLock = Nothing
        ' Update opacity value
        Opacity = Opacity + 0.1
        If Opacity > 1 Then Opacity = 0
    Loop
    ' Clear objects
    Set SurfaceModifier = Nothing
    Set DXSurface1 = Nothing
    Set DXSurface2 = Nothing
    Set DXSurfaceResult = Nothing
    Set DXSurfaceOutput = Nothing
    Set SurfaceFactory = Nothing
End Sub
